/*******************************************************************************
 * Copyright  2006 Brad Anderson
 * 
 *	TODO:
 *		- the glow needs to be cut off
 *		- in affiliation with Amazon.com
 *		- better interface bar for new, popular, find bar
 *	CHANGES:
 *		1.0.1
 *		- reduced cpu usage
 *		- turns off the glow fader when hidden (stops processor utilization)
 *		- after getting new content it moves the scroller to the top
 *		- changes made for compatibility with Opera
 *
 *		1.0
 *		- initial release
 *
 ******************************************************************************/


var window_x_min = 290, window_y_min = 230, window_y_closed = 91, closedState = 0, width, height;

var myVersion = "1.0.2", showUpgrade = true;
var request, scrollArea;
var tab = "";

var inBackground = false;
var forceReloadOnShow = false;
var errorIndex = -1;
var errorWaitTimes = [1, 2, 5, 12, 25, 60, 120];

var goodRefreshDelay = 6 * 3600;


var prefImage = "2.8", prefHighDef = "", prefSeason = "";
var nextDate = "", previousDate = "", nowDate = "", newestVersion = "", newestVersion="";

var isLoaded = false;

var grabType;

var debugWithoutInternet = false, debugPrefs = false, debug = false, debugError = false;

var isDashboard = false, isSafari = false, isOpera = false;

if(window.opera) {
	isOpera = true;
	alert("isOpera");
} else if(window.widget) {
	isSafari = true;
	isDashboard = true;
} else {
	isSafari = true;
}


function setWindowSize(w, h)
{
	logFunc("setWindowSize: (" + w + ", " + h +")");
	
	w = parseInt(w);
	h = parseInt(h);
	
	if(w < window_x_min) 		// minimum width
		w = window_x_min;

	if(closedState == 2)
		h = window_y_closed;
	else if(h < window_y_min) 		// minimum height
		h = window_y_min;
	
	width = w;
	height = h;
	
	if(window.widget)
		window.resizeTo(w,h);		// resizes the widget's window
		
	//	when in a widget and not the close state, save the w and h
	if(window.widget && closedState == 0) {
		widget.setPreferenceForKey(w + "", "width");
		widget.setPreferenceForKey(h + "", "height");
	}
	scrollArea.refresh();
	scrollAreaMI.refresh();
	
	recenterArrows();
}



function returnFromBack()
{
	logFunc("returnFromBack");
	
	renderExpandArrow();
	renderFrame();
	scrollArea.refresh();
	scrollAreaMI.refresh();
}


var reloadHackTimeout = null;

function onshow() {
	if(reloadHackTimeout)
		clearTimeout(reloadHackTimeout);
	reloadHack = null;
	logFunc("onshow");
	
	inBackground = false;
	
	if(forceReloadOnShow) {
		log('forcing to refresh on show');
		updateContent();
	} else if(!isLoaded)
		clickNew();
	
	forceReloadOnShow = false;
	
	if(isDashboard)
		StartGlow();
		
}

function onhide() {
	logFunc("onhide");
	StopGlow();
	inBackground = true;
}

function onfocus() {
	logFunc("onfocus");
	
	if(!isLoaded)
		clickNew();
}

function onblur() {
	logFunc("onblur");
}

function captureKey(ev) {
	ev = ev || window.event;             // gets the event in ie or ns
	kCode = ev.keyCode || ev.which;   // gets the keycode in ie or ns
	
	if (kCode == 13) { // return
		if(gebi("newVersion").style.display == "block") {
			hideNewVersion();
		} else if(isOnBack) {
			hidePrefs();
			if(prefsAreUpdated)
				updateContent();
		}
		return false;
	}
	return true;
}

	if(window.widget) {
		widget.onshow = onshow;
		widget.onhide = onhide;
		window.onfocus = onfocus;
		window.onblur = onblur;
	}
function load()
{
	logFunc("load");
	
	if(isOpera) {
		gebi("instructions").style.bottom = "18px";
		gebi("moreGCP").style.display = "none";
	}
	
	scrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollBar"));
	scrollArea = new AppleScrollArea(document.getElementById("content"), scrollbar);
	scrollArea.scrollsHorizontally = false;
	scrollArea.singlepressScrollPixels = 25;
	scrollArea.focus(); // for key control when first loading in Safari
	
	scrollbarMI = new AppleVerticalScrollbar(document.getElementById("myScrollBarMI"));
	scrollAreaMI = new AppleScrollArea(document.getElementById("moreInfo"), scrollbarMI);
	scrollAreaMI.scrollsHorizontally = false;
	scrollAreaMI.singlepressScrollPixels = 25;
	
	document.onkeypress = captureKey;
	if(window.widget) {
		if(debugPrefs) {
			widget.setPreferenceForKey(null, "img");
			widget.setPreferenceForKey(null, "closedState");
			widget.setPreferenceForKey(null, "highdef");
			widget.setPreferenceForKey(null, "tvseries");
			widget.setPreferenceForKey(null, "width");
			widget.setPreferenceForKey(null, "height");
			widget.setPreferenceForKey(null, "expanded");
		}
		if(!widget.preferenceForKey("img")) {
			alert("first load, setting options");
			widget.setPreferenceForKey(prefImage, "img");
			widget.setPreferenceForKey(prefHighDef, "highdef");
			widget.setPreferenceForKey(prefSeason, "tvseries");
			widget.setPreferenceForKey("340", "width");
			widget.setPreferenceForKey("300", "height");
			widget.setPreferenceForKey(1, "expanded");
		}
		prefImage = widget.preferenceForKey("img");
		prefHighDef = widget.preferenceForKey("highdef");
		prefSeason = widget.preferenceForKey("tvseries");
		width = parseInt(widget.preferenceForKey("width"));
		height = parseInt(widget.preferenceForKey("height"));
		isExanded = parseInt(widget.preferenceForKey("expanded"));
		
		setWindowSize(width, height);
		if(debug)
			alert("is expanded: " + isExanded);
	}
	setPopup(gebi("hdoption"), prefHighDef);
	setPopup(gebi("tvoption"), prefSeason);
	setPopup(gebi("covers"), prefImage);
	
	window.onfocus = function () { scrollArea.focus(); }
	window.onblur = function () { scrollArea.blur(); }
	
	var frontWindow = gebi("front");
	
	if(frontWindow) {
		frontWindow.addEventListener('mousemove', mousemove, false);
		frontWindow.addEventListener('mouseout', mouseexit, false);
    }
	
    //gebi("findInput").blur();
    
   	var doneButton = gebi('done-button');
   	if(doneButton && typeof createGenericButton != "undefined")
		createGenericButton (doneButton, "Done", function() { hidePrefs(); if(prefsAreUpdated) updateContent();}, 58);
	
	
	
	redoUpgrade();
	
	//	rotate disc will call click new
	rotateDisc(false);
	slideGlow();
	if(isDashboard)
		StartGlow();
	findSetColor();
	
	if(isOpera)
		onshow();
	else
		reloadHackTimeout = setTimeout(onshow, 3000);
	
	if(!isExanded)
		toggleExpanded();
		
	renderExpandArrow();
	
	logFunc("load end");
	
	return 0;
}

var expandTimer = 0, expandVar = 0; // 0 expanded, 1 closing, 2 closed, -1 opening
function toggleExpanded()
{
	logFunc("toggleExpanded");
	
	if(closedState == 0) { //clicked to close
		closedState = 1;
	} else if(closedState == 1) { //is closing, clicked to open
		closedState = -1;
	} else if(closedState == 2) { // is closed, clicked to open
		rotateDisc();
		closedState = -1;
	} else if(closedState == -1) { // is opening, clicked to close
		closedState = 1;
	}
	widget.setPreferenceForKey(closedState < 0 ? "1" : "0", "expanded");
	
	if(!expandTimer)
		expandTimer = setTimeout(animateExpandable, 33);
}
function animateExpandable()
{
	expandVar += ( 0.7 * (1-expandVar) + 0.005) * (closedState);
	if(expandVar < 0) {
		expandVar = 0;
		expandTimer = null;
		closedState = 0;
	} else if(expandVar > 1) {
		expandVar = 1;
		expandTimer = null;
		closedState = 2;
	} else {
		expandTimer = setTimeout(animateExpandable, 33);
	}
	renderExpandArrow();
	recenterArrows();
	
	window.resizeTo(width, parseInt(Math.floor((1 - expandVar) * height + (expandVar) * window_y_closed)));		// resizes the widget's window
}
function renderExpandArrow()
{
	var ctx = gebi("expandBox").getContext('2d');
	
	ctx.save();
	ctx.clearRect(0,0,20,20);
	ctx.translate(10,10);
	ctx.rotate(Math.PI / 2 - expandVar * Math.PI / 2);
	ctx.drawImage(expandArrow, -10, -10);
	ctx.restore();
}


function logFunc(txt)
{
	log(txt);
}
function log(txt)
{
	
	if(debug) {
		if(gebi("debug"))
			gebi("debug").innerHTML += " -- " + txt;
		else
			alert(txt);
	}
}

function clickNew()
{
	logFunc("clickNew");
	
	if(tab != "new") {
		gebi("findInput").blur();
		tab = "new";
		grabType = "down";
		updateContent();
	}
}

function clickPopular()
{
	logFunc("clickPopular");
	
	if(tab != "popular") {
		gebi("findInput").blur();
		tab = "popular";
		grabType = "down";
		updateContent();
	}
}



function clickFind()
{
	logFunc("clickFind");
	
	if(gebi("findInput").value.length > 0) {
		tab = "find";
		grabType = "down";
		updateContent();
		gebi("findInput").focus();
		gebi("findInput").select();
	}
}



function clickFindText()
{
	logFunc("clickFindText");
	
	tab = "find";
	hightlightTabs();
}

/**
 *	Called when a key is pressed in the find box
 */
function findKeyPress(ev)
{
	logFunc("findKeyPress");
	
	if(gebi("findInput").value.length > 0) {
		
		ev = ev || window.event;             // gets the event in ie or ns
		kCode = ev.keyCode || ev.which;   // gets the keycode in ie or ns
		
		/* in ie, when pressing the ctrl + shift + key, it gives the key code for the capitalized key (probably because shift is pressed) 
		   in ns pressing ctrl, shift and another key doesn't change the keycode
		   thus, the || and two different numbers */
	
		if (kCode == 13) { // ctrl+w
			clickFind();
			return false;
		}
	}
	
	return true;
}

function findSetColor()
{
	logFunc("findSetColor");
	
	if(gebi("findInput").value.length > 0) {
		gebi("findTab").style.color = "black";
		gebi("findTab").style.cursor = "pointer";
		
	} else { //the length is 0 so disable the find
		gebi("findTab").style.color = "#777";
		gebi("findTab").style.cursor = "";
	}
}




function hightlightTabs()
{
	logFunc("hightlightTabs");
	
	gebi("findTab").style.fontWeight = "";
	gebi("popularTab").style.fontWeight = "";
	gebi("newTab").style.fontWeight = "";
	
	if(tab == "find") {
		gebi("findTab").style.fontWeight = "bold";
	} else if(tab == "popular") {
		gebi("popularTab").style.fontWeight = "bold";
	} else {
		gebi("newTab").style.fontWeight = "bold";
	}
	setLeftMouseState();
	setRightMouseState();
}

var contentRefreshTimer = null;
function updateContent()
{
	logFunc("updateContent");
	
	if(inBackground) {
		log("update waiting until onshow");
		forceReloadOnShow = true;
		return;
	}
	
	if(request)
		request.abort();
	request = null;
		
	if(contentRefreshTimer)
		clearTimeout(contentRefreshTimer);
	contentRefreshTimer = null;
	
	hightlightTabs();
	
	if(tab == "find") {
		url = getDVDFindUrl(gebi("findInput").value);
	} else if(tab == "popular") {
		url = getDVDPopularUrl();
	} else {
		url = getDVDNewUrl(nowDate);
	}
	
	startGrab(grabType);
	
	request = loadXMLDoc(url, setContent);
	request.send("");
	request.tab = tab;
}
function setContent(t)
{
	logFunc("setContent: " + request);
	
	if(!contentRefreshTimer && request)
    // only if req shows "loaded"
    if (request.readyState == 4) {
        // only if "OK"
        if (!debugError && (request.status == 200 || debugWithoutInternet)) {
            // ...processing statements go here...
            if(request.responseXML && !debugWithoutInternet) {
				node = request.responseXML.getElementsByTagName("content")[0];
				
				gebi("content").innerHTML = node.firstChild.nodeValue;
				
				node = request.responseXML.getElementsByTagName("previousDate")[0];
				previousDate = node.firstChild.nodeValue;
				
				node = request.responseXML.getElementsByTagName("nextDate")[0];
				nextDate = node.firstChild.nodeValue;
				
				node = request.responseXML.getElementsByTagName("version")[0];
				newestVersion = node.firstChild.nodeValue;
            } else if(debugWithoutInternet) {
            	gebi("content").innerHTML = "grabbed fake data from internet";
            	previousDate = "2006-09-23";
            	nextDate = "2006-10-6";
            	newestVersion = "some other version";
            }
            
            scrollArea.refresh();
            scrollArea.verticalScrollTo(0);
            
            errorIndex = -1;
            if(showUpgrade) {
            	triggerInstructions(2500);
            }
            if(myVersion != newestVersion && showUpgrade) {
            	showNewVersion(newestVersion);
            	newestVersion = myVersion;
            }
            
            setLeftMouseState();
            setRightMouseState();
            	
			showUpgrade = false;
            
            isLoaded = true;
            if(!contentRefreshTimer)
				contentRefreshTimer = setTimeout("updateContent();", goodRefreshDelay * 1000);
        } else {
            isLoaded = false;
            log('no content, ' + new Date());
        	gebi("content").innerHTML = "<div class='error fillArea'>I could not download the dvd data.  <br />" + 
        		"You either aren't connected to the internet or the server is down for a few minutes. <br />" + 
        		"<center>Click the disc to reload.<br />" + 
        		"<a href='#' onclick='clearContent()'>Close</a></center>" + 
        		"</div>";
        		
            if(!contentRefreshTimer) {
				errorIndex++;
				if(errorIndex >= errorWaitTimes.length)
					errorIndex = errorWaitTimes.length - 1;
				
				contentRefreshTimer = setTimeout("updateContent();", 
							errorWaitTimes[errorIndex] * 60 * 1000);
			}
        }
        closeGrab();
		
        request = null;
    }
}

function clearContent()
{
	gebi("content").innerHTML = "";
}

var prefsAreUpdated = false;
function updatePrefs()
{
	logFunc("updatePrefs");
	
	prefsAreUpdated = true;
	prefHighDef = getPopup(gebi("hdoption"));
	prefSeason = getPopup(gebi("tvoption"));
	prefImage = getPopup(gebi("covers"));
	
	if(window.widget) {
		widget.setPreferenceForKey(prefImage, "img");
		widget.setPreferenceForKey(prefHighDef, "highdef");
		widget.setPreferenceForKey(prefSeason, "tvseries");
	}
	scrollArea.refresh();
	updateContent();
}


function clickUpgrade()
{
	if(isOpera)
		widget.openURL('http://www.globalconscious.com/dashboard/?operadvdreleases=1');
	else
		widget.openURL('http://www.globalconscious.com/dashboard/?dashdvdreleases=1');
}



